import lxml.etree as et
import csv
import logging

prefix_map = {"g": "http://base.google.com/ns/1.0"}

keys= ['Variant group', 
       'product ID',
       'ean',
       'category',
       'title',
       'short description',
       'long description',
       'brand',
       'web price',
       'VAT',
       'weight',
       'width',
       'lenght',
       'height',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media']

def readOldXML(file, new_name):
    root = []
    variant_counter = 0
    for event, elem in et.iterparse(file, strip_cdata = False):
        if elem.tag == "item":
            entry = {
                'Variant group': '', 
                'product ID': '', 
                'ean': '', 
                'category': '',
                'title': '', 
                'short description': '', 
                'long description': '', 
                'brand': '', 
                'web price': '', 
                'VAT': '', 
                'weight': '', 
                'width': '', 
                'lenght': '', 
                'height': '', 
                'media1': '', 
                'media2': '', 
                'media3': '', 
                'media4': '', 
                'media5': '', 
                'media6': '', 
                'media7': '', 
                'media8': '', 
                'media9': '', 
                'media10': '', 
                'media11': '', 
                'media12': '', 
                'media13': '', 
                'media14': '', 
            }
            
            entry['Variant group'] = variant_counter
            variant_counter += 1
            
            entry['product ID'] = elem.find('g:id', prefix_map).text
            
            if elem.find('g:product_width', prefix_map):
                entry['width'] = elem.find('g:product_width', prefix_map).text
            if elem.find('g:product_length', prefix_map):    
                entry['length'] = elem.find('g:product_length', prefix_map).text
            if elem.find('g:product_height', prefix_map):
                entry['width'] = elem.find('g:product_height', prefix_map).text
            if elem.find('g:product_weight', prefix_map):
                entry['weight'] = elem.find('g:product_weight', prefix_map).text
            
            entry['web price'] = elem.find('g:price', prefix_map).text.split()[0]
            
            try:
                entry['ean'] = elem.find('g:gtin', prefix_map).text
            
            except AttributeError:
                entry['ean'] = "Brak"
                
            entry['category'] = elem.find('g:product_type', prefix_map).text
            
            entry['title'] = elem.find('g:title', prefix_map).text
            
            entry['media1'] = elem.find('g:image_link', prefix_map).text
            counter = 2
            for image in elem.findall('g:additional_image_link', prefix_map):
                entry['media'+str(counter)] = image.text
                counter += 1
                if counter == 13:
                    break
            
            entry['long description'] = elem.find('g:description', prefix_map).text
            
            try:
                entry['brand'] = elem.find('g:brand', prefix_map).text
            except AttributeError:
                entry['brand'] = "brak"
            
            elem.clear()
            entry_to_save = []
            counter = 0 
            for x in entry:
                entry_to_save.append(entry[x])
                counter += 1
            root.append(entry_to_save)
            logging.info('Successfully appended entry ' + str(entry['product ID']))
    save_to_csv(root, new_name)
    

def save_to_csv(root, new_name):
    with open(new_name, 'w', newline='', encoding='utf-8') as output_file:
        counter1 = 0
        for x in keys:
            if counter1 == len(keys)-1:
                output_file.write(x+'\n')
            else:
                output_file.write(x+';')
            counter1 += 1
        
        dict_writer = csv.writer(output_file, delimiter=';')
        dict_writer.writerows(root)

def execute(old_name, new_name): 
    readOldXML(old_name, new_name)